package com.company.losttransient.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.JmixProperty;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "ENTITY_B")
@Entity
public class EntityB {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Composition
    @OneToMany(mappedBy = "entityB")
    @OnDelete(DeletePolicy.CASCADE)
    private List<EntityBMapping> entityBMapping;

    @InstanceName
    @Column(name = "NAME", nullable = false)
    @NotNull
    private String name;

    @JmixProperty
    @Transient
    private Boolean createEntityCInstance = false;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Boolean getCreateEntityCInstance() {
        return createEntityCInstance;
    }

    public void setCreateEntityCInstance(Boolean createEntityCInstance) {
        this.createEntityCInstance = createEntityCInstance;
    }

    public List<EntityBMapping> getEntityBMapping() {
        return entityBMapping;
    }

    public void setEntityBMapping(List<EntityBMapping> entityBMapping) {
        this.entityBMapping = entityBMapping;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}